//Dan  7/25/2004  \DanLP115\Include\ColorVec.inl
#pragma once

#include "ColorVec.h"
#include "ColorBuf.h"
#include "HalfColorBuf.h"

//*********************************************************************
//*** ColorVector
//*********************************************************************
inline ColorVector::ColorVector(const HalfColorBuf &other) {
   m_red   = other.Red();
   m_green = other.Green();
   m_blue  = other.Blue();
}
//*********************************************************************
//*** ColorVectorAlpha
//*********************************************************************
inline ColorVectorAlpha::ColorVectorAlpha(const HalfColorBufAlpha &other) :
   m_color(other.Color()) {
   m_alpha = other.Alpha();
}
inline ColorVectorAlpha::ColorVectorAlpha(const ColorBuf &other) {
   SetRed((float)other.values.red   / MAXCOLOR);
   SetGreen((float)other.values.green / MAXCOLOR);
   SetBlue((float)other.values.blue   / MAXCOLOR);
   SetAlpha((float)other.values.alpha / MAXCOLOR);
}
