#pragma once

#ifdef _WIN64
#ifndef _AMD64_
#define _AMD64_
#endif
#define PtrToInt(x)   PtrToInt((VOID *)(x))   //64 bit version expects void*, not INT_PTR
#define PtrToLong(x)  PtrToLong((VOID *)(x))  //64 bit version expects void*, not INT_PTR
#define PtrToUint(x)  PtrToUint((VOID *)(x))  //64 bit version expects void*, not INT_PTR
#define PtrToUlong(x) PtrToUlong((VOID *)(x)) //64 bit version expects void*, not INT_PTR

#ifndef GetWindowLongPtr
#define GetWindowLongPtr GetWindowLong
#endif

#ifndef SetWindowLongPtr
#define SetWindowLongPtr SetWindowLong
#endif

#ifndef GetClassLongPtr
#define GetClassLongPtr GetClassLong
#endif

#ifndef SetClassLongPtr
#define SetClassLongPtr SetClassLong
#endif

#ifndef ULongToPtr
#define ULongToPtr(x) x
#endif

#ifndef LongToPtr
#define LongToPtr(x) x
#endif

#ifndef PtrToUint
#define PtrToUint(x) x
#endif

#ifndef PtrToInt
#define PtrToInt(x) x
#endif

//#ifndef LRESULT
//#define LRESULT LONG_PTR
//#endif

#else

#ifndef GWLP_WNDPROC
#define GWLP_WNDPROC GWL_WNDPROC
#endif

#ifndef GWLP_HINSTANCE
#define GWLP_HINSTANCE GWL_HINSTANCE
#endif

#ifndef GWLP_HWNDPARENT
#define GWLP_HWNDPARENT GWL_HWNDPARENT
#endif

#ifndef GWLP_USERDATA
#define GWLP_USERDATA GWL_USERDATA
#endif

#ifndef GCLP_MENUNAME
#define GCLP_MENUNAME GCL_MENUNAME
#endif

#ifndef GCLP_HBRBACKGROUND
#define GCLP_HBRBACKGROUND GCL_HBRBACKGROUND
#endif

#ifndef GCLP_HCURSOR
#define GCLP_HCURSOR GCL_HCURSOR
#endif

#ifndef GCLP_HICON
#define GCLP_HICON GCL_HICON
#endif

#ifndef GCLP_HMODULE
#define GCLP_HMODULE GCL_HMODULE
#endif

#ifndef GCLP_WNDPROC
#define GCLP_WNDPROC GCL_WNDPROC
#endif

#ifndef GCLP_HICONSM
#define GCLP_HICONSM GCL_HICONSM
#endif

#ifndef GetWindowLongPtr
#define GetWindowLongPtr GetWindowLong
#endif

#ifndef SetWindowLongPtr
#define SetWindowLongPtr SetWindowLong
#endif

#ifndef GetClassLongPtr
#define GetClassLongPtr GetClassLong
#endif

#ifndef SetClassLongPtr
#define SetClassLongPtr SetClassLong
#endif

#ifndef DWORD_PTR
#define DWORD_PTR DWORD
#endif

#ifndef LONG_PTR
#define LONG_PTR LONG
#endif

#ifndef ULONG_PTR
#define ULONG_PTR ULONG
#endif

#ifndef INT_PTR
#define INT_PTR INT
#endif

#ifndef UINT_PTR
#define UINT_PTR UINT
#endif

#ifndef LRESULT
#define LRESULT LONG
#endif

#endif
