#if !defined(AFX_EXPORTMODELSDIALOG_H__58C09837_D8D2_11D3_83A5_00E0811049D9__INCLUDED_)
#define AFX_EXPORTMODELSDIALOG_H__58C09837_D8D2_11D3_83A5_00E0811049D9__INCLUDED_

#pragma once
// ExportModelsDialog.h : header file
//
#include "StrClass.h"

/////////////////////////////////////////////////////////////////////////////
// CExportModelsDialog dialog

class HModelCache;

class CExportModelsDialog final : public CPluginDialog {
    // Construction
public:
    CExportModelsDialog() = default; // standard constructor
    CExportModelsDialog(HObjectCacheContainer *hocc);

    void FillCombo(int id) const;

    // Dialog Data
    IEModelParms *m_iemp{};
    HObjectCacheContainer *m_hocc{};
    String m_dir;
    CCheckListBox m_checklistbox;
    CList<HModelCache *, HModelCache *> m_selected;

    //{{AFX_DATA(CExportModelsDialog)
    enum { IDD = IDD_EXPORTMODELS_DIALOG };

    BOOL m_generatemodelmaps{};
    BOOL m_applybump{};
    int m_maxsize{};
    int m_minsize{};
    int m_subtype{};
    //}}AFX_DATA

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CExportModelsDialog)
protected:
    void DoDataExchange(CDataExchange *pDX) override; // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:
    // Generated message map functions
    //{{AFX_MSG(CExportModelsDialog)
    void OnOK() override;
    BOOL OnInitDialog() override;
    afx_msg void OnBrowse();
    afx_msg void OnMaxSize();
    afx_msg void OnMinSize();
    afx_msg void OnGeneratemodelmaps();
    //}}AFX_MSG
DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXPORTMODELSDIALOG_H__58C09837_D8D2_11D3_83A5_00E0811049D9__INCLUDED_)
