#include "StdAfx.h"
#include "resource.h"
#include "Brick.h"

enum { P_CHOR };

extern "C" __declspec(dllexport) BOOL HxtLoadCommandEntry(const UINT index, ObjectType & objtype) {
    switch (index) {
    case P_CHOR:
        objtype = HOT_CHOR;
        return TRUE;
    }
    return FALSE;
}

extern "C" __declspec(dllexport) BOOL HxtOnAddCommandMenu(HTreeObject * htreeobject, const UINT index, String & menuname, MenuCategory & mc, BOOL & disabled) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState())
      
    CString string;
    BOOL rc = string.LoadString(IDS_STRING1);
    if (rc) {
        menuname = string;
        disabled = FALSE;
    } else {
        menuname = "Error Loadstring";
        disabled = TRUE;
    }
    mc = MC_WIZARD;

    switch (index) {
    case P_CHOR:
        return TRUE;
    }
    return FALSE;
}

extern "C" __declspec(dllexport) BOOL HxtOnCommand(HTreeObject * htreeobject, const UINT index) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState())
        switch (index) {
        case P_CHOR:
            return ((CBrickApp*)AfxGetApp())->OnChor((HChor*)htreeobject);
        }
    return FALSE;
}
