#include "StdAfx.h"
#include "resource.h"
#include "Smooth.h"

extern "C" __declspec(dllexport) BOOL HxtLoadCommandEntry(const UINT index, ObjectType &objtype) {
    switch (index) {
        case 0:
            objtype = HOT_GROUP;
            return TRUE;
    }
    return FALSE;
}

extern "C" __declspec(dllexport) BOOL HxtOnAddCommandMenu(HTreeObject *htreeobject, const UINT index, String &menuname, MenuCategory &mc, BOOL &disabled) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState())

    if (!((HAnimObject *)htreeobject)->IsCache())
        return FALSE;

    CString string;
    BOOL rc = string.LoadString(IDS_STRING1);
    if (rc) {
        menuname = string;
        disabled = FALSE;
    } else {
        menuname = "Error Loadstring";
        disabled = TRUE;
    }
    mc = MC_WIZARD;
    return TRUE;
}

extern "C" __declspec(dllexport) BOOL HxtOnCommand(HTreeObject *htreeobject, const UINT index) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState())

    HGroup *hg = (HGroup *)htreeobject;
    HModelCache *hmc = (HModelCache *)hg->GetParentOfType(HOT_MODEL);
    return ((CSmoothApp *)AfxGetApp())->OnGroup(hmc, hg);
}
